<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fo="http://www.w3.org/1999/XSL/Format"
                version='1.0'>


<xsl:import href="../../../lib/docbook/docbook/xsl/fo/docbook.xsl" />
<xsl:import href="../../../lib/docbook/custom-styles/docbook/plain/xsl/customized.fo-base.xsl" />

<xsl:param name="fop1.extensions" select="1" />
<!-- should be 200a, but fop does not support it. -->
<xsl:param name="ulink.hyphenate">&#x200b;</xsl:param>

<!-- Base specific templates -->
<xsl:param name="paper.type" select="'A4'" />

<xsl:param name="section.autolabel.max.depth" select="2" />
<xsl:param name="insert.xref.page.number">yes</xsl:param>
<xsl:param name="local.l10n.xml" select="document('')"/>
<l:i18n xmlns:l="http://docbook.sourceforge.net/xmlns/l10n/1.0">
  <l:l10n language="en">
    <l:context name="xref">
      <l:template name="page.citation" text=" (page %p)"/>
    </l:context>
  </l:l10n>
</l:i18n>

<xsl:param name="variablelist.as.blocks" select="1"></xsl:param>

<xsl:param name="body.start.indent">0pt</xsl:param>
<xsl:param name="page.margin.inner">0.79in</xsl:param>
<xsl:param name="page.margin.outer">0.79in</xsl:param>

<!-- doc.revision, base.version and doc.last.modified -->
<xsl:param name="doc.revision">@doc.revision@</xsl:param>
<xsl:param name="doc.last.modified">@doc.last.modified@</xsl:param>
<xsl:param name="base.version">@base.version@</xsl:param>

<xsl:template match="helptext">
	<xsl:choose>
		<xsl:when test="@webonly = '0'">	
			<xsl:apply-templates />
		</xsl:when>
	</xsl:choose>
</xsl:template>

<xsl:template match="seeother|other">
</xsl:template>

<xsl:template match="nohelp">
	<xsl:apply-templates />
</xsl:template>

<xsl:template match="pubdate" mode="book.titlepage.verso.auto.mode">
	<fo:block xmlns:fo="http://www.w3.org/1999/XSL/Format"
		xsl:use-attribute-sets="book.titlepage.verso.style" space-before="1em">
		<xsl:apply-templates select="." mode="book.titlepage.verso.mode" />
		<xsl:value-of select="$doc.last.modified" />
	</fo:block>
</xsl:template>

<xsl:template match="releaseinfo" mode="book.titlepage.verso.auto.mode">
	<fo:block xmlns:fo="http://www.w3.org/1999/XSL/Format"
		xsl:use-attribute-sets="book.titlepage.verso.style" space-before="0.5em">
		<xsl:apply-templates select="." mode="book.titlepage.verso.mode" />
		<xsl:text>Version:&#10;</xsl:text>
	</fo:block>
	<fo:block>
		<xsl:value-of select="$base.version" />
		<xsl:text> (build #</xsl:text>
		<xsl:value-of select="$doc.revision" />
		<xsl:text>)</xsl:text>
	</fo:block>
</xsl:template>

<xsl:template match="guilabel">
  <xsl:call-template name="inline.boldseq"/>
</xsl:template>

<xsl:template match="guibutton">
  <xsl:call-template name="inline.boldseq"/>
</xsl:template>

<xsl:template match="baseversion">
	<xsl:value-of select="$base.version" />
</xsl:template>

</xsl:stylesheet>

