/**
	$Id: DataLoader.java 4900 2009-04-21 12:54:42Z martin $

	Copyright (C) 2009 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.plugins;

/**
 	A helper interface for the {@link SimpleExporter} to get data 
 	that in some way are associated with an item.
 	
  	@author martin
 	@version 2.12
 	@base.modified $Date: 2009-04-21 14:54:42 +0200 (Tue, 21 Apr 2009) $
 */
interface DataLoader<T>
{

	/**
		Get the value for the specified property.
		@param exportedProperty The property to get the value for
		@param item The item that holds the value
	 * @throws Exception If failing to get the data.
	 */
	public Object getData(ExportedProperty exportedProperty, T item)
			throws Exception;

}