/**
	$Id: ThrowableUtil.java 4618 2008-10-30 10:41:41Z nicklas $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.error;

import java.io.PrintWriter;
import java.io.StringWriter;

/**
	Utility class for working with {@link Throwable}:s.
	
	@author Nicklas
	@version 2.9
	@base.modified $Date: 2008-10-30 11:41:41 +0100 (Thu, 30 Oct 2008) $
*/
public class ThrowableUtil
{

	/**
		Convert a stacktrace to a string that is usually printed
		with the {@link Throwable#printStackTrace()} method.
		@param t The throwable
		@return The string representation of the stack trace
	*/
	public static String stackTraceToString(Throwable t)
	{
		StringWriter sw = new StringWriter();
		PrintWriter pw = new PrintWriter(sw);
		t.printStackTrace(pw);
		pw.close();
		return sw.toString();
	}
}
