<%-- $Id: view_configuration.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.ParameterInfo"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.util.JarClassLoader"
	import="net.sf.basedb.util.ToStringComparator"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.NameablePluginAdaptor"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.TreeSet"
	import="java.util.List"
	import="java.util.Collections"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.PLUGINCONFIGURATION;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String root = request.getContextPath() + "/";
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);

	String title = null;
	PluginConfiguration configuration = PluginConfiguration.getById(dc, itemId);
	
	final boolean createPermission = sc.hasPermission(Permission.CREATE, itemType);
	final boolean writePermission = configuration.hasPermission(Permission.WRITE);
	final boolean deletePermission = configuration.hasPermission(Permission.DELETE);
	final boolean sharePermission = configuration.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = configuration.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = configuration.isRemoved();
	final boolean isUsed = isRemoved && configuration.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = configuration.isOwner();

	final Set<GuiContext> contexts = new TreeSet<GuiContext>(new ToStringComparator<GuiContext>(false));
	PluginDefinition plugin = null;
	Nameable nameableProxy = null;
	boolean readPlugin = true;
	boolean configurable = false;
	try
	{
		plugin = configuration.getPluginDefinition();
		nameableProxy = new NameablePluginAdaptor(plugin);
		contexts.addAll(plugin.getGuiContexts());
		configurable = plugin.isInteractive() && plugin.supportsConfigurations();
	}
	catch (PermissionDeniedException ex)
	{
		readPlugin = false;
	}
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, configuration);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function copyItem()
		{
			Main.copyItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'ShareConfiguration', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 150);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function configure()
		{
			Main.openPopup('../../common/plugin/index.jsp?ID=<%=ID%>&cmd=ConfigurePlugin&pluginconfiguration_id=<%=itemId%>', 'ConfigurePlugin', 800, 600);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Plugin configurations" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(configuration.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="properties">
		<t:tab id="properties" title="Properties">
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this plugin configuration" : "You do not have permission to edit this plugin configuration"%>" 
			/>
			<tbl:button 
				disabled="<%=!createPermission%>" 
				image="<%=createPermission ? "copy.gif" : "copy_disabled.gif"%>"
				onclick="copyItem()" 
				title="Copy&hellip;" 
				tooltip="<%=createPermission ? "Create a copy of this configuration" : "You do not have permission to create new configurations"%>"
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!configuration.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this plugin configuration" : "You do not have permission to delete this plugin configuration"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=configuration.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this plugin configuration" : "You do not have permission to restore this plugin configuration"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this plugin configuration to other user, groups and projects" : "You do not have permission to share this plugin configuration"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="setOwner()" 
				title="Set owner&hellip;"
				tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				image="runplugin.gif"
				onclick="configure()"
				title="Configure&hellip;"
				tooltip="Configure this plugin"
				visible="<%=configurable && writePermission%>"
			/>
			<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'pluginconfiguration.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(configuration)%></i></div>
			<%
			if (configuration.isRemoved() || configuration.isShared())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=configuration.isShared()%>"> This item is shared to other users, groups and/or projects</base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing="0">
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(configuration.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Registered</td>
				<td><%=dateFormatter.format(configuration.getEntryDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Plugin</td>
				<td>
					<%=Base.getLinkedName(ID, nameableProxy, plugin == null, true)%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Type</td>
				<td><%=plugin == null ? "<i>- denied -</i>" : plugin.getMainType().toString()%></td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=configuration%>" property="owner" /></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(configuration.getDescription())%></td>
			</tr>
			</table>
		
			<%		
			// Tables with users/groups/projects that this item is shared to
			MultiPermissions mp = new MultiPermissions(Collections.singleton(configuration));
			ItemResultIterator<User> users = mp.getUsers().iterate(dc);
			ItemResultIterator<Group> groups = mp.getGroups().iterate(dc);
			ItemResultIterator<Project> projects = mp.getProjects().iterate(dc);
			
			if (users.hasNext() || groups.hasNext() || projects.hasNext())
			{
				%>
				<h4 class="docked">Shared to</h4>
				<tbl:table 
					id="itemsSharedTo"
					clazz="itemlist"
					columns="all"
				>
					<tbl:columndef 
						id="itemType"
						title="Item type"
					/>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="permissions"
						title="Permissions"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						while(projects.hasNext())
						{
							Project project = projects.next();
							Set<Permission> permissions = mp.getPermissions(project).values().iterator().next();
							%>			
							<tbl:row>
								<tbl:cell column="itemType"><%=project.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=project.isRemoved()%>"
								/><%=Base.getLinkedName(ID, project, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						while(groups.hasNext())
						{
							Group group = groups.next();
							Set<Permission> permissions = mp.getPermissions(group).values().iterator().next();
							%>
							<tbl:row>							
								<tbl:cell column="itemType"><%=group.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=group.isRemoved()%>"
								/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%	
						}
						while (users.hasNext())
						{
							User user = users.next();
							Set<Permission> permissions = mp.getPermissions(user).values().iterator().next();
							%>
							<tbl:row>							
								<tbl:cell column="itemType"><%=user.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=user.isRemoved()%>"
								/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				<%
			}
			else
			{
				%>
				<h4>Shared to</h4>
				This configuration is not shared 
				(or, you don't have permission to view the ones it is shared to).
				<%
			}
			%>
		</div>

			</t:tab>
			
			<t:tab id="parameters" title="Configuration parameters" >
			<div class="boxed">
			<table class="form" cellspacing="0">
			<%
			if (plugin != null)
			{
				List<String> names = new java.util.ArrayList<String>(configuration.getParameterNames());
				if (names == null || names.size() == 0)
				{
					%>
					No parameters has been specified.
					<%
				}
				else
				{
					Collections.sort(names);
					for (String name : names)
					{
						StringBuilder sb = new StringBuilder();
						String displayValue = "";
						String description = "";
						try
						{
							ParameterInfo pi = configuration.getParameterInfo(name);
							if (pi.getLabel() != null) name = HTML.encodeTags(pi.getLabel());
							description = HTML.encodeTags(pi.getDescription());
							List<?> values = pi.getValues();
							int i = 0;
							for (Object value : values)
							{
								if (value != null)
								{
									if (i > 0) sb.append(", ");
									i++;
									if (value instanceof BasicItem)
									{
										BasicItem item = (BasicItem)value;
										String itemName = "";
										if (item instanceof File)
										{
											sb.append(Base.getLinkedFile(ID, (File)item, false, true, true, root));
										}
										else 
										{
											if (item instanceof Nameable)
											{
												itemName = ((Nameable)item).getName();
											}
											else
											{
												itemName = item.toString();
											}
											sb.append(Base.getLink(ID, HTML.encodeTags(itemName), 
												item.getType(), item.getId(), item.hasPermission(Permission.WRITE)));
										}
									}
									else if (value instanceof Date)
									{
										sb.append(dateFormatter.format((Date)value));
									}
									else
									{
										sb.append(HTML.encodeTags(value.toString()));
									}
								}
							}
							displayValue = sb.toString();
						}
						catch (Throwable ex)
						{
							displayValue = "<i>ERROR: "+ex.getMessage()+"</i>";
						}
						%>
						<tr>
							<td class="prompt"><span title="<%=description%>"><%=name%></span></td>
							<td>
								<%=displayValue%>
							</td>
						</tr>
						<%
					}
				}
			}
			%>
			</table>
			</div>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations" 
				tooltip="View annotation values" 
				visible="<%=plugin != null && plugin.supports("net.sf.basedb.core.plugin.AnnotationSetterPlugin") %>">
				<div class="boxed">
				<jsp:include page="../../common/annotations/list_annotations.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
				</div>
			</t:tab>
			
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
