<%-- $Id: info.jsp 4840 2009-03-24 14:55:03Z martin $
	------------------------------------------------------------------
	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.FileStoreEnabled"
	import="net.sf.basedb.core.FileSetMember"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemNotFoundException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.NestedIterator"
	import="net.sf.basedb.util.overview.GenericOverview"
	import="net.sf.basedb.util.overview.OverviewUtil"
	import="net.sf.basedb.util.overview.Node"
	import="net.sf.basedb.util.overview.ValidationOptions"
	import="net.sf.basedb.util.overview.Validator"
	import="net.sf.basedb.util.overview.Severity"
	import="net.sf.basedb.util.overview.Failure"
	import="net.sf.basedb.util.overview.Fix"
	import="java.util.ArrayList"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.Iterator"
	import="java.util.Collection"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
private String getPath(Node node)
{
	Node parent = node.getParent();
	if (parent == null) return "";
	String path = getPath(parent);
	if (parent.getNodeType() == Node.Type.FOLDER)
	{
		//path += "/" + HTML.encodeTags(parent.getTitle());
	}
	else
	{
		BasicItem item = parent.getItem();
		if (path.length() > 0)
		{
			path += "<img src=\"../../images/submenu.gif\" style=\"padding: 0px 4px 5px 6px;\" >";
		}
		if (item.hasPermission(Permission.WRITE))
		{
			path += "<a href=\"javascript:editItem('" + item.getType().name() + "', " + item.getId() + 
				")\" title=\"Edit this item\" style=\"padding-right: 4px; white-space: nowrap;\">" + HTML.encodeTags(parent.getTitle()) + "</a>";
		}
		else
		{
			path += HTML.encodeTags(parent.getTitle());
		}
	}
	return path;
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	GenericOverview overview = OverviewUtil.getCurrentOverview(sc);
	ValidationOptions options = overview.getValidationOptions();
	String nodeId = request.getParameter("nodeId");
	Boolean showFailures = Values.getBoolean(request.getParameter("show_failures"), false);
	Node node = overview.getNode(nodeId);
	if (node == null) node = overview.getRootNode();

	BasicItem item = node.getItem();
	List<Failure> failures = overview.getFailures();
	if (failures == null) failures = new LinkedList<Failure>();
	%>
	<base:page title="" type="popup">
	<base:head scripts="" styles="newjoust.css">
	<script language="JavaScript">
	function editItem(itemType, itemId, extraUrl)
	{
		Main.viewOrEditItem('<%=ID%>', itemType, itemId, true, extraUrl);
	}
	function editAnnotation(itemType, itemId, annotationTypeId)
	{
		var url = getRoot() + 'common/annotations/annotate.jsp?ID=<%=ID%>';
		url += '&item_type=' + itemType;
		url += '&item_id=' + itemId;
		url += '&annotationtype_id='+annotationTypeId;
		url += '&standalone=1';
		Main.openPopup(url, 'EditAnnotation', 700, 460);
	}
	function editInheritedAnnotation(itemType, itemId, annotationTypeId)
	{
		var url = getRoot() + 'common/annotations/inherit.jsp?ID=<%=ID%>';
		url += '&item_type='+itemType;
		url += '&item_id='+itemId;
		url += '&annotationtype_id='+annotationTypeId;
		url += '&standalone=1';
		Main.openPopup(url, 'EditAnnotation', 700, 460);
	}
	function editDataFile(itemType, itemId)
	{
		Main.viewOrEditItem('<%=ID%>', itemType, itemId, true, '&tab=datafiles');
	}
	</script>
	</base:head>

		<base:body>
			<table class="form">
			<tr>
				<td class="prompt">Path</td>
				<td><%=getPath(node)%></td>
			</tr>
			<%
			if (item instanceof FileSetMember)
			{
				FileSetMember member = null;
				boolean notFound = false;
				try
				{	
					member = FileSetMember.getById(dc, item.getId());
				}
				catch (ItemNotFoundException ex)
				{
					notFound = true;
				}
				File file = null;
				DataFileType dft = null;
				boolean deniedFile = false;
				boolean deniedFileType = false;
				if (member != null)
				{
					try
					{
						file = member.getFile();
					}
					catch (PermissionDeniedException ex)
					{
						deniedFile = true;
					}
					try
					{
						dft = member.getDataFileType();
					}
					catch (PermissionDeniedException ex)
					{
						deniedFileType = true;
					}
				}
				if (dft != null || file != null)
				{
					%>
					<tr>
						<td class="prompt">
							<%=dft == null ? "Data file" : HTML.encodeTags(dft.getName())%>
						</td>
						<td>
							<%
							if (deniedFile)
							{
								%>
								<i>- denied -</i>
								<%
							}
							else
							{
								if (file.hasPermission(Permission.WRITE))
								{
									%>
									<a href="javascript:editItem('FILE', <%=file.getId()%>)" 
										title="Edit this item"><%=HTML.encodeTags(file.getName())%></a>
									<%
								}
								else
								{
									%>
									<%=HTML.encodeTags(file.getName()) %>
									<%
								}
								%>
								<%=Base.getFileLinks(ID, file, "../../") %>
								<%
							}
							%>
						</td>
					</tr>
					<%
				}
				else
				{
					%>
					<tr>
					<td class="prompt"><%=HTML.encodeTags(node.getTitle())%></td>
					<td>
						<%=notFound ? "<i>- not found -</i>" : "<i>- denied -</i>"%>
					</td>
					</tr>
					<%
				}
			}
			else
			{
				%>
				<tr>
					<td class="prompt"><%=node.getNodeType() == Node.Type.FOLDER ? 
						"Folder" : item != null ? item.getType().toString() : "Item"%></td>
					<td>
						<%
						if (item != null && item.hasPermission(Permission.WRITE))
						{
							%>
							<a href="javascript:editItem('<%=item.getType().name()%>', <%=item.getId()%>)" 
								title="Edit this item"><%=HTML.encodeTags(node.getTitle())%></a>
							<%
						}
						else
						{
							%>
							<%=HTML.encodeTags(node.getTitle())%>
							<%
						}
						%>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<td class="prompt">Errors (children)</td>
				<%
				if (showFailures)
				{
				%>
					<td><%=node.getNumErrors()+node.getChildErrors()%> (<%=node.getChildErrors()%>)</td>
				<%
				}
				else
				{				
				%>
					<td><i>- n/a -</i></td>
				<%
				}
				%>
			</tr>
			<tr>
				<td class="prompt">Warnings (children)</td>
				<%
				if (showFailures)
				{
				%>
					<td><%=node.getNumWarnings()+node.getChildWarnings()%> (<%=node.getChildWarnings()%>)</td>
				<%
				}
				else
				{				
				%>
					<td><i>- n/a -</i></td>
				<%
				}
				%>
			</tr>
			<%
			if (item instanceof Nameable)
			{
				Nameable nameable = (Nameable)item;
				%>
				<tr>
					<td class="prompt">Description</td>
					<td><%=HTML.niceFormat(nameable.getDescription())%></td>
				</tr>
				<%
			}
			%>
			</table>
			<p>
			
			<%
			List<Annotation> annotations = null;
			String annotationsTitle = "";
			Annotatable annotatable = null;
			if (item instanceof Annotation)
			{
				Annotation a = (Annotation)item;
				dc.reattachItem(a);
				annotations = Collections.singletonList(a);
				try
				{
					annotatable = a.getAnnotationSet().getItem();
				}
				catch (Throwable t)
				{}
				annotationsTitle = "Annotation values";
			}
			else if (item instanceof AnnotationType)
			{
				// Find the annotatable parent
				Node parentNode = node;
				while (parentNode != null)
				{
					BasicItem parentItem = parentNode.getItem();
					if (parentItem instanceof Annotatable)
					{
						annotatable = (Annotatable)parentItem;
						dc.reattachItem((BasicItem)annotatable);
						if (annotatable.isAnnotated())
						{
							annotations = annotatable.getAnnotationSet().findAnnotations(dc, (AnnotationType)item, true);
						}
						annotationsTitle = "Annotation values";
						break;
					}
					parentNode = parentNode.getParent();
				}
			}
			else if (item instanceof Annotatable)
			{
				annotationsTitle = "Annotations &amp; protocol parameters";
				annotatable = (Annotatable)item;
				if (annotatable.isAnnotated())
				{
					dc.reattachItem((BasicItem)annotatable);
	
					// Load annotations & protocol parameters
					List<Node> nodes = new LinkedList<Node>();
					Node folder = node.getChild("annotations");
					if (folder != null && folder.getChildren() != null) nodes.addAll(folder.getChildren());
					Node protocolNode = node.getChild("protocol");
					if (protocolNode != null && protocolNode.getChildren() != null) nodes.addAll(protocolNode.getChildren());
					if (nodes.size() > 0)
					{
						annotations = new LinkedList<Annotation>();
						for (Node n : nodes)
						{
							BasicItem aItem = n.getItem();
							if (aItem instanceof Annotation)
							{
								annotations.add((Annotation)aItem);
							}
							else if (aItem instanceof AnnotationType)
							{
								annotations.addAll(annotatable.getAnnotationSet().findAnnotations(dc, (AnnotationType)aItem, true));
							}
						}
					}
				}
			}
			if (annotations != null && annotations.size() > 0)
			{
				%>
				<h4><%=annotationsTitle%></h4>
				<table border=0 cellspacing=0 cellpadding=0>
				<%
				for (Annotation a : annotations)
				{
					a = Annotation.getById(dc, a.getId());
					String unitSymbol = a.hasUnit() ? "&nbsp;" + a.getUnitSymbol(null) : "";
					AnnotationType at = null;
					Annotatable annotationOwner = null;
					try
					{
						at = a.getAnnotationType();
					}
					catch (Throwable t)
					{}
					try
					{
						annotationOwner = a.getAnnotationSet().getItem();
					}
					catch (Throwable t)
					{}
					String icon = at != null && at.isProtocolParameter() ? 
							"parameter.gif" : "joust/annotation.gif";
					String editLink = null;
					String editTooltip = null;
					if (annotatable != null && annotatable.hasPermission(Permission.WRITE) && at != null)
					{
						if (annotatable.equals(annotationOwner))
						{
							editLink = "editAnnotation('" + annotatable.getType().name() + "', " + annotatable.getId() + ", " + at.getId() + ")";
							editTooltip = "Edit the values of this annotation";
						}
						else
						{
							editLink = "editInheritedAnnotation('" + annotatable.getType().name() + "', " + annotatable.getId() + ", " + at.getId() + ")";
							editTooltip = "Inherit this annotation from another item";
						}
					}
					%>
					<tr>
						<td><base:icon visible="<%=icon != null%>" image="<%=icon%>" />&nbsp;</td>
						<td>
							<%
							if (at != null)
							{
								if (at.hasPermission(Permission.WRITE))
								{
									%>
									<a href="javascript:editItem('<%=at.getType().name()%>', <%=at.getId()%>)" 
										title="Edit this annotation type"><%=HTML.encodeTags(at.getName())%></a>
									<%
								}
								else
								{
									%>
									<%=HTML.encodeTags(at.getName())%>
									<%
								}
							}
							else
							{
								%>
								<%=a.getValueType() %>
								<%
							}
							%>
						</td>
						<td>
							<%
							if (annotationOwner != null && !annotationOwner.equals(annotatable))
							{
								%>
								<base:icon image="bullet.gif" tooltip="Annotation is inherited from" />
								<%
								String ownerName = annotationOwner instanceof Nameable ?
										((Nameable)annotationOwner).getName() : annotationOwner.toString();
								if (annotationOwner.hasPermission(Permission.WRITE))
								{
									%>
									<a href="javascript:editItem('<%=annotationOwner.getType().name()%>', <%=annotationOwner.getId()%>)" 
										title="Edit this item"><%=HTML.encodeTags(ownerName)%></a>
									<%
								}
								else
								{
									%>
									<%=HTML.encodeTags(ownerName)%>
									<%
								}
							}
							%>
						</td>
						<td><base:icon image="bullet.gif" /></td>
						<td><%=Values.getString(a.getValues(null), ", ", true)%><%=unitSymbol%></td>
						<td>&nbsp;
							<%
							if (editLink != null)
							{
								%><base:icon image="edit.gif" onclick="<%=editLink%>" 
									tooltip="<%=editTooltip%>" />
								<%
							}
							%>
						</td>
					</tr>
					<%
				}
				%>
				</table>
				<%
			}			
			if (showFailures)
			{
				%>
				<h4>Failure details</h4>			
				<table>
				<%
				int numFailures = 0;
				for (Failure failure : failures)
				{
					Validator validator = failure.getValidator();
					Severity severity = options.getSeverity(validator);
					if (failure.getNode() == node && severity != Severity.IGNORE)
					{
						numFailures++;
						List<Fix> fixes = failure.getFixes();
						%>
						<tr>
							<td><base:icon image="<%=severity == Severity.ERROR ? 
								"error.gif" : "warning.gif"%>" /></td>
							<td><b><%=HTML.encodeTags(failure.getMessage())%></b></td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dotted #999999;"></td>
							<td style="border-bottom: 1px dotted #999999;">
								<%=HTML.encodeTags(validator.getDescription())%><br>
								<%
								if (fixes != null && fixes.size() > 0)
								{
									for (Fix fix : fixes)
									{
										if (fix == null) continue;
										BasicItem fixItem = fix.getItem();
										if (fixItem.hasPermission(Permission.WRITE))
										{
											String fixIt = "";
											if (fix.isAnnotationFix())
											{
												AnnotationType at = fix.getAnnotationType();
												if (fix.isFromInherited())
												{
													fixIt = "editInheritedAnnotation('" + fixItem.getType().name() + "', " + 
														fixItem.getId() + ", " + at.getId() + ")";
												}
												else
												{
													fixIt = "editAnnotation('" + fixItem.getType().name() + "', " + 
														fixItem.getId() + ", " + at.getId() + ")";
												}
											}
											else if (fix.isDataFileFix())
											{
												FileSetMember member = fix.getFileSetMember();
												fixIt = "editDataFile('" + fixItem.getType().name() + "', " + 
													fixItem.getId() + ")";
											}
											else
											{
												fixIt = "editItem('" + fixItem.getType().name() + "', " + 
													fixItem.getId() + ")";
											}
											%>
											<base:icon image="fixit.png" 
												style="padding-bottom: 4px;" /><a href="javascript:<%=fixIt%>"
												title="Edit this item to fix the problem"><%=HTML.encodeTags(fix.getMessage())%></a><br>
											<%
										}
									}
								}
								%>
							</td>
						</tr>
						<%
					}
				}
				%>
				</table>
				<%
				if (numFailures == 0)
				{
					%>
					No validation failures on this item
					<%
				}				
			}
			%>
		</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
